// -    GPIO,FSMC,LCD  DMA !!! 

#include "LCD.inc"

#define W 160
#define H 128

void FSMC_GPIO_Init(void)
{
 GPIO_InitTypeDef gpio;
 
 RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB|RCC_AHB1Periph_GPIOD|RCC_AHB1Periph_GPIOE,ENABLE);
 
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource14,GPIO_AF_FSMC); // D0
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource15,GPIO_AF_FSMC); // D1
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource0 ,GPIO_AF_FSMC); // D2
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource1 ,GPIO_AF_FSMC); // D3
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource7 ,GPIO_AF_FSMC); // D4
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource8 ,GPIO_AF_FSMC); // D5
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource9 ,GPIO_AF_FSMC); // D6
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource10,GPIO_AF_FSMC); // D7
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource11,GPIO_AF_FSMC); // D8
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource12,GPIO_AF_FSMC); // D9
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource13,GPIO_AF_FSMC); //D10
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource14,GPIO_AF_FSMC); //D11
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource15,GPIO_AF_FSMC); //D12
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource8 ,GPIO_AF_FSMC); //D13
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource9 ,GPIO_AF_FSMC); //D14
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource10,GPIO_AF_FSMC); //D15
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource11,GPIO_AF_FSMC); //A16 => RS
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource7 ,GPIO_AF_FSMC); //NE1 => CS
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource4 ,GPIO_AF_FSMC); //NOE => RD
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource5 ,GPIO_AF_FSMC); //NWE => WR
  
 gpio.GPIO_Pin=GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_14|GPIO_Pin_15;
 gpio.GPIO_Mode=GPIO_Mode_AF;
 gpio.GPIO_Speed=GPIO_Speed_100MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOD,&gpio);
 
 gpio.GPIO_Pin=GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;
 gpio.GPIO_Mode=GPIO_Mode_AF;
 gpio.GPIO_Speed=GPIO_Speed_100MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOE,&gpio);
 
 //LCD_RESET B11
 gpio.GPIO_Pin=GPIO_Pin_11;
 gpio.GPIO_Mode=GPIO_Mode_OUT;
 gpio.GPIO_Speed=GPIO_Speed_100MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOB,&gpio);
 
 //LCD_LED D12
 gpio.GPIO_Pin=GPIO_Pin_12;
 gpio.GPIO_Mode=GPIO_Mode_OUT;
 gpio.GPIO_Speed=GPIO_Speed_100MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOD,&gpio);
}

void FSMC_Init(void)
{
 FSMC_NORSRAMTimingInitTypeDef fsmcTiming;
 FSMC_NORSRAMInitTypeDef fsmc;
 
 RCC_AHB3PeriphClockCmd(RCC_AHB3Periph_FSMC,ENABLE);

 fsmcTiming.FSMC_AddressSetupTime=0;
 fsmcTiming.FSMC_AddressHoldTime=0;
 fsmcTiming.FSMC_DataSetupTime=3;
 fsmcTiming.FSMC_BusTurnAroundDuration=0;
 fsmcTiming.FSMC_CLKDivision=0;
 fsmcTiming.FSMC_DataLatency=0;
 fsmcTiming.FSMC_AccessMode=FSMC_AccessMode_A;

 fsmc.FSMC_Bank=FSMC_Bank1_NORSRAM1;
 fsmc.FSMC_DataAddressMux=FSMC_DataAddressMux_Disable;
 fsmc.FSMC_MemoryType=FSMC_MemoryType_SRAM;
 fsmc.FSMC_MemoryDataWidth=FSMC_MemoryDataWidth_16b;
 fsmc.FSMC_BurstAccessMode=FSMC_BurstAccessMode_Disable;
 fsmc.FSMC_WaitSignalPolarity=FSMC_WaitSignalPolarity_Low;
 fsmc.FSMC_WrapMode=FSMC_WrapMode_Disable;
 fsmc.FSMC_WaitSignalActive=FSMC_WaitSignalActive_BeforeWaitState;
 fsmc.FSMC_WriteOperation=FSMC_WriteOperation_Enable;
 fsmc.FSMC_WaitSignal=FSMC_WaitSignal_Disable;
 fsmc.FSMC_AsynchronousWait=FSMC_AsynchronousWait_Disable;
 fsmc.FSMC_ExtendedMode=FSMC_ExtendedMode_Disable;
 fsmc.FSMC_WriteBurst=FSMC_WriteBurst_Disable;
 fsmc.FSMC_ReadWriteTimingStruct=&fsmcTiming;
 fsmc.FSMC_WriteTimingStruct=&fsmcTiming;

 FSMC_NORSRAMInit(&fsmc); 
 FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1,ENABLE);
}

void Frame_To_LCD(void)
{
 register u32* FB=(u32*)VideoBuffer;
 register u32 i=(W*H)>>1;
 while(i--)LCD_Reg_DAT32=FB++[0];
}

void Frame_To_LCD_DMA_Init(void)
{
 DMA_InitTypeDef DMA_InitStructure;

 RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA2,ENABLE);

 DMA_DeInit(DMA2_Stream0);

 while(DMA_GetCmdStatus(DMA2_Stream0)!=DISABLE);

 DMA_InitStructure.DMA_Channel = DMA_Channel_0;  
 DMA_InitStructure.DMA_PeripheralBaseAddr=(u32)&VideoBuffer[0];
 DMA_InitStructure.DMA_Memory0BaseAddr   =(u32)&LCD_Reg_DAT32;
 DMA_InitStructure.DMA_DIR               =DMA_DIR_MemoryToMemory;
 DMA_InitStructure.DMA_BufferSize        =(W*H)>>1;
 DMA_InitStructure.DMA_PeripheralInc     =DMA_PeripheralInc_Enable;
 DMA_InitStructure.DMA_MemoryInc         =DMA_MemoryInc_Disable;
 DMA_InitStructure.DMA_PeripheralDataSize=DMA_PeripheralDataSize_Word;
 DMA_InitStructure.DMA_MemoryDataSize    =DMA_MemoryDataSize_Word;
 DMA_InitStructure.DMA_Mode              =DMA_Mode_Normal;
 DMA_InitStructure.DMA_Priority          =DMA_Priority_High; //High
 DMA_InitStructure.DMA_FIFOMode          =DMA_FIFOMode_Disable;
 DMA_InitStructure.DMA_FIFOThreshold     =DMA_FIFOThreshold_Full;
 DMA_InitStructure.DMA_MemoryBurst       =DMA_MemoryBurst_Single;
 DMA_InitStructure.DMA_PeripheralBurst   =DMA_PeripheralBurst_Single;

 DMA_Init(DMA2_Stream0,&DMA_InitStructure);
}

void Frame_To_LCD_DMA(void)
{
 while(DMA_GetCmdStatus(DMA2_Stream0)!=DISABLE); //while(DMA_GetCurrentMemoryTarget(DMA2_Stream0));
 DMA_ClearITPendingBit(DMA2_Stream0,DMA_IT_TCIF0);
 DMA_Cmd(DMA2_Stream0,ENABLE);
}

int main(void)
{
 FSMC_GPIO_Init();
 FSMC_Init();
 LCD_Position((240-W)>>1,((240+W)>>1)-1,(320-H)>>1,((320+H)>>1)-1);
 Frame_To_LCD_DMA_Init();
 FRAME:
  Frame_To_LCD_DMA(); //Frame_To_LCD();
 goto FRAME;
}
